Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jdbc.support
Class JdbcUtils

    java.lang.Object
      org.springframework.jdbc.support.JdbcUtils

    public abstract class JdbcUtils

extends Object

Generic utility methods for working with JDBC. Mainly for internal use within the framework, but also useful for custom JDBC access code.

Author:
  Thomas Risberg, Juergen Hoeller

Field Summary
`static int` | `TYPE_UNKNOWN` Constant that indicates an unknown (or unspecified) SQL type.

Constructor Summary
`JdbcUtils()`

Method Summary
`static void` | `closeConnection(Connection con)` Close the given JDBC Connection and ignore any thrown exception.
`static void` | `closeResultSet(ResultSet rs)` Close the given JDBC ResultSet and ignore any thrown exception.
`static void` | `closeStatement(Statement stmt)` Close the given JDBC Statement and ignore any thrown exception.
`static String` | `commonDatabaseName(String source)` Extract a common name for the database in use even if various drivers/platforms provide varying names.
`static String` | `convertUnderscoreNameToPropertyName(String name)` Convert a column name with underscores to the corresponding property name using "camel case".
`static Object` | `extractDatabaseMetaData(DataSource dataSource, DatabaseMetaDataCallback action)` Extract database meta data via the given DatabaseMetaDataCallback.
`static Object` | `extractDatabaseMetaData(DataSource dataSource, String metaDataMethodName)` Call the specified method on DatabaseMetaData for the given DataSource, and extract the invocation result.
`static Object` | `getResultSetValue(ResultSet rs, int index)` Retrieve a JDBC column value from a ResultSet, using the most appropriate value type.
`static boolean` | `isNumeric(int sqlType)` Check whether the given SQL type is numeric.
`static String` | `lookupColumnName(ResultSetMetaData resultSetMetaData, int columnIndex)` Determine the column name to use.
`static boolean` | `supportsBatchUpdates(Connection con)` Return whether the given JDBC driver supports JDBC 2.0 batch updates.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### TYPE_UNKNOWN

    public static final int TYPE_UNKNOWN

  Constant that indicates an unknown (or unspecified) SQL type.

  See Also:
    `Types`, Constant Field Values

Constructor Detail

### JdbcUtils

    public JdbcUtils()

Method Detail

### closeConnection

    public static void closeConnection(Connection con)

  Close the given JDBC Connection and ignore any thrown exception. This is useful for typical finally blocks in manual JDBC code.

  Parameters:
    `con` - the JDBC Connection to close (may be `null`)

### closeStatement

    public static void closeStatement(Statement stmt)

  Close the given JDBC Statement and ignore any thrown exception. This is useful for typical finally blocks in manual JDBC code.

  Parameters:
    `stmt` - the JDBC Statement to close (may be `null`)

### closeResultSet

    public static void closeResultSet(ResultSet rs)

  Close the given JDBC ResultSet and ignore any thrown exception. This is useful for typical finally blocks in manual JDBC code.

  Parameters:
    `rs` - the JDBC ResultSet to close (may be `null`)

### getResultSetValue

    public static Object getResultSetValue(ResultSet rs,
                                           int index)
                                    throws SQLException

  Retrieve a JDBC column value from a ResultSet, using the most appropriate value type. The returned value should be a detached value object, not having any ties to the active ResultSet: in particular, it should not be a Blob or Clob object but rather a byte array respectively String representation.

  Uses the `getObject(index)` method, but includes additional "hacks" to get around Oracle 10g returning a non-standard object for its TIMESTAMP datatype and a `java.sql.Date` for DATE columns leaving out the time portion: These columns will explicitly be extracted as standard `java.sql.Timestamp` object.

  Parameters:
    `rs` - is the ResultSet holding the data
    `index` - is the column index
  Returns:
    the value object
  Throws:
    `SQLException` - if thrown by the JDBC API
  See Also:
    `Blob`, `Clob`, `Timestamp`

### extractDatabaseMetaData

    public static Object extractDatabaseMetaData(DataSource dataSource,
                                                 DatabaseMetaDataCallback action)
                                          throws MetaDataAccessException

  Extract database meta data via the given DatabaseMetaDataCallback.

  This method will open a connection to the database and retrieve the database metadata. Since this method is called before the exception translation feature is configured for a datasource, this method can not rely on the SQLException translation functionality.

  Any exceptions will be wrapped in a MetaDataAccessException. This is a checked exception and any calling code should catch and handle this exception. You can just log the error and hope for the best, but there is probably a more serious error that will reappear when you try to access the database again.

  Parameters:
    `dataSource` - the DataSource to extract metadata for
    `action` - callback that will do the actual work
  Returns:
    object containing the extracted information, as returned by the DatabaseMetaDataCallback's `processMetaData` method
  Throws:
    `MetaDataAccessException` - if meta data access failed

### extractDatabaseMetaData

    public static Object extractDatabaseMetaData(DataSource dataSource,
                                                 String metaDataMethodName)
                                          throws MetaDataAccessException

  Call the specified method on DatabaseMetaData for the given DataSource, and extract the invocation result.

  Parameters:
    `dataSource` - the DataSource to extract meta data for
    `metaDataMethodName` - the name of the DatabaseMetaData method to call
  Returns:
    the object returned by the specified DatabaseMetaData method
  Throws:
    `MetaDataAccessException` - if we couldn't access the DatabaseMetaData or failed to invoke the specified method
  See Also:
    `DatabaseMetaData`

### supportsBatchUpdates

    public static boolean supportsBatchUpdates(Connection con)

  Return whether the given JDBC driver supports JDBC 2.0 batch updates.

  Typically invoked right before execution of a given set of statements: to decide whether the set of SQL statements should be executed through the JDBC 2.0 batch mechanism or simply in a traditional one-by-one fashion.

  Logs a warning if the "supportsBatchUpdates" methods throws an exception and simply returns `false` in that case.

  Parameters:
    `con` - the Connection to check
  Returns:
    whether JDBC 2.0 batch updates are supported
  See Also:
    `DatabaseMetaData.supportsBatchUpdates()`

### commonDatabaseName

    public static String commonDatabaseName(String source)

  Extract a common name for the database in use even if various drivers/platforms provide varying names.

  Parameters:
    `source` - the name as provided in database metedata
  Returns:
    the common name to be used

### isNumeric

    public static boolean isNumeric(int sqlType)

  Check whether the given SQL type is numeric.

  Parameters:
    `sqlType` - the SQL type to be checked
  Returns:
    whether the type is numeric

### lookupColumnName

    public static String lookupColumnName(ResultSetMetaData resultSetMetaData,
                                          int columnIndex)
                                   throws SQLException

  Determine the column name to use. The column name is determined based on a lookup using ResultSetMetaData.

  This method implementation takes into account recent clarifications expressed in the JDBC 4.0 specification:

  columnLabel - the label for the column specified with the SQL AS clause. If the SQL AS clause was not specified, then the label is the name of the column.

  Parameters:
    `resultSetMetaData` - the current meta data to use
    `columnIndex` - the index of the column for the look up
  Returns:
    the column name to use
  Throws:
    `SQLException` - in case of lookup failure

### convertUnderscoreNameToPropertyName

    public static String convertUnderscoreNameToPropertyName(String name)

  Convert a column name with underscores to the corresponding property name using "camel case". A name like "customer_number" would match a "customerNumber" property name.

  Parameters:
    `name` - the column name to be converted
  Returns:
    the name using "camel case"

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2007 The Spring Framework.